%COMPUTES OPTIMAL ELLIPSE

clear
x1=2; x2=4; y1=3.5;

B=(x1+x2)/2; A=(x2-x1)/2; T=y1;
c=sqrt(2*(A^2-T^2));
if imag(c)==0
    a=sqrt(2)*A;
    b=sqrt(a^2-c^2);
  else
    b=sqrt(2)*A;
    a=sqrt(b^2-c^2);
 end

d=B;


t=linspace(0,2*pi,100);

plot([x1,x1],[-y1,y1])
hold on
plot([x2,x2],[-y1,y1])
plot([x1,x2],[y1,y1])
plot([x1,x2],[-y1,-y1])

if imag(c)==0
  plot(d+a*cos(t)+i*b*sin(t))
 else
  plot(d+b*cos(t)+i*a*sin(t))
end
plot(real(d+c),imag(d+c),'o');plot(real(d-c),imag(d-c),'o')

hold off
axis('square')

%%convergence factor conv
   v=(abs(d+c)+abs(d-c))/abs(2*c);
   R=v+sqrt(v^2-1);
   
   r=(abs(a)+abs(b))/abs(c);
   
   conv1=r/R
   
   
      conv2=sqrt(2)*(A+T)/(B+sqrt(B^2+2*(T^2-A^2)))
	
   
   
   R=(d+sqrt(d^2-(c)^2))/abs(c);
       r=(abs(a)+abs(b))/abs(c);
	
   conv3=r/R	
return
